# BlAmazonApi.ProductApi

All URIs are relative to *http://104.198.83.158:80*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getProductsBrowseNodeAttributes**](ProductApi.md#getProductsBrowseNodeAttributes) | **GET** /products/browseNodes/{nodeId}/attributes | Get attributes within a specified browse node for the title generating
[**getProductsBrowseNodeValidValue**](ProductApi.md#getProductsBrowseNodeValidValue) | **GET** /products/browseNodes/{nodeId}/validValue | Get the browse node&#39;s valid value for submiting a flat file
[**getProductsStatus**](ProductApi.md#getProductsStatus) | **GET** /products/status | Get Product API status


<a name="getProductsBrowseNodeAttributes"></a>
# **getProductsBrowseNodeAttributes**
> GetProductsBrowseNodeAttributesResponse getProductsBrowseNodeAttributes(nodeId)

Get attributes within a specified browse node for the title generating

Return Attributes

### Example
```javascript
var BlAmazonApi = require('bl_amazon_api');

var apiInstance = new BlAmazonApi.ProductApi();

var nodeId = "nodeId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getProductsBrowseNodeAttributes(nodeId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **nodeId** | **String**|  | 

### Return type

[**GetProductsBrowseNodeAttributesResponse**](GetProductsBrowseNodeAttributesResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getProductsBrowseNodeValidValue"></a>
# **getProductsBrowseNodeValidValue**
> GetProductsBrowseNodeValidValueResponse getProductsBrowseNodeValidValue(nodeId)

Get the browse node&#39;s valid value for submiting a flat file

Return Valid Value

### Example
```javascript
var BlAmazonApi = require('bl_amazon_api');

var apiInstance = new BlAmazonApi.ProductApi();

var nodeId = "nodeId_example"; // String | 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getProductsBrowseNodeValidValue(nodeId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **nodeId** | **String**|  | 

### Return type

[**GetProductsBrowseNodeValidValueResponse**](GetProductsBrowseNodeValidValueResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getProductsStatus"></a>
# **getProductsStatus**
> GetProductsStatusResponse getProductsStatus()

Get Product API status

Returns Product API status

### Example
```javascript
var BlAmazonApi = require('bl_amazon_api');

var apiInstance = new BlAmazonApi.ProductApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getProductsStatus(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**GetProductsStatusResponse**](GetProductsStatusResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

