/**
 * bl-amazon-api
 * This is an API documentation for the Bluehack Amazon Service.
 *
 * OpenAPI spec version: 0.0.5
 * Contact: master@bluehack.net
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/GetProductsBrowseNodeAttributesResponse', 'model/GetProductsBrowseNodeValidValueResponse', 'model/GetProductsStatusResponse'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/GetProductsBrowseNodeAttributesResponse'), require('../model/GetProductsBrowseNodeValidValueResponse'), require('../model/GetProductsStatusResponse'));
  } else {
    // Browser globals (root is window)
    if (!root.BlAmazonApi) {
      root.BlAmazonApi = {};
    }
    root.BlAmazonApi.ProductApi = factory(root.BlAmazonApi.ApiClient, root.BlAmazonApi.GetProductsBrowseNodeAttributesResponse, root.BlAmazonApi.GetProductsBrowseNodeValidValueResponse, root.BlAmazonApi.GetProductsStatusResponse);
  }
}(this, function(ApiClient, GetProductsBrowseNodeAttributesResponse, GetProductsBrowseNodeValidValueResponse, GetProductsStatusResponse) {
  'use strict';

  /**
   * Product service.
   * @module api/ProductApi
   * @version 0.0.5
   */

  /**
   * Constructs a new ProductApi. 
   * @alias module:api/ProductApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getProductsBrowseNodeAttributes operation.
     * @callback module:api/ProductApi~getProductsBrowseNodeAttributesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetProductsBrowseNodeAttributesResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get attributes within a specified browse node for the title generating
     * Return Attributes
     * @param {String} nodeId 
     * @param {module:api/ProductApi~getProductsBrowseNodeAttributesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetProductsBrowseNodeAttributesResponse}
     */
    this.getProductsBrowseNodeAttributes = function(nodeId, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling getProductsBrowseNodeAttributes");
      }


      var pathParams = {
        'nodeId': nodeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetProductsBrowseNodeAttributesResponse;

      return this.apiClient.callApi(
        '/products/browseNodes/{nodeId}/attributes', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProductsBrowseNodeValidValue operation.
     * @callback module:api/ProductApi~getProductsBrowseNodeValidValueCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetProductsBrowseNodeValidValueResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get the browse node&#39;s valid value for submiting a flat file
     * Return Valid Value
     * @param {String} nodeId 
     * @param {module:api/ProductApi~getProductsBrowseNodeValidValueCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetProductsBrowseNodeValidValueResponse}
     */
    this.getProductsBrowseNodeValidValue = function(nodeId, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling getProductsBrowseNodeValidValue");
      }


      var pathParams = {
        'nodeId': nodeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetProductsBrowseNodeValidValueResponse;

      return this.apiClient.callApi(
        '/products/browseNodes/{nodeId}/validValue', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProductsStatus operation.
     * @callback module:api/ProductApi~getProductsStatusCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetProductsStatusResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Product API status
     * Returns Product API status
     * @param {module:api/ProductApi~getProductsStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetProductsStatusResponse}
     */
    this.getProductsStatus = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetProductsStatusResponse;

      return this.apiClient.callApi(
        '/products/status', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
