/**
 * bl-amazon-api
 * This is an API documentation for the Bluehack Amazon Service.
 *
 * OpenAPI spec version: 0.0.5
 * Contact: master@bluehack.net
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/GetDictionaryBrowseNodesAllResponse', 'model/GetDictionaryProductsAttrsResponse', 'model/GetDictionaryProductsAttrsSubAttrsResponse', 'model/GetDictionaryProductsAttrsSubAttrsWordsResponse', 'model/GetDictionarySubAttrsWordsResponse', 'model/GetDictionaryWordsFilteredResponse', 'model/GetDictionaryWordsResponse', 'model/GetToolTitlesResponse', 'model/PostDictionaryProductsAttrsResponse', 'model/PostDictionaryProductsAttrsSubAttrsResponse', 'model/PostDictionaryProductsAttrsSubAttrsWordsResponse', 'model/PostDictionaryWordsResponse'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/GetDictionaryBrowseNodesAllResponse'), require('../model/GetDictionaryProductsAttrsResponse'), require('../model/GetDictionaryProductsAttrsSubAttrsResponse'), require('../model/GetDictionaryProductsAttrsSubAttrsWordsResponse'), require('../model/GetDictionarySubAttrsWordsResponse'), require('../model/GetDictionaryWordsFilteredResponse'), require('../model/GetDictionaryWordsResponse'), require('../model/GetToolTitlesResponse'), require('../model/PostDictionaryProductsAttrsResponse'), require('../model/PostDictionaryProductsAttrsSubAttrsResponse'), require('../model/PostDictionaryProductsAttrsSubAttrsWordsResponse'), require('../model/PostDictionaryWordsResponse'));
  } else {
    // Browser globals (root is window)
    if (!root.BlAmazonApi) {
      root.BlAmazonApi = {};
    }
    root.BlAmazonApi.ToolApi = factory(root.BlAmazonApi.ApiClient, root.BlAmazonApi.GetDictionaryBrowseNodesAllResponse, root.BlAmazonApi.GetDictionaryProductsAttrsResponse, root.BlAmazonApi.GetDictionaryProductsAttrsSubAttrsResponse, root.BlAmazonApi.GetDictionaryProductsAttrsSubAttrsWordsResponse, root.BlAmazonApi.GetDictionarySubAttrsWordsResponse, root.BlAmazonApi.GetDictionaryWordsFilteredResponse, root.BlAmazonApi.GetDictionaryWordsResponse, root.BlAmazonApi.GetToolTitlesResponse, root.BlAmazonApi.PostDictionaryProductsAttrsResponse, root.BlAmazonApi.PostDictionaryProductsAttrsSubAttrsResponse, root.BlAmazonApi.PostDictionaryProductsAttrsSubAttrsWordsResponse, root.BlAmazonApi.PostDictionaryWordsResponse);
  }
}(this, function(ApiClient, GetDictionaryBrowseNodesAllResponse, GetDictionaryProductsAttrsResponse, GetDictionaryProductsAttrsSubAttrsResponse, GetDictionaryProductsAttrsSubAttrsWordsResponse, GetDictionarySubAttrsWordsResponse, GetDictionaryWordsFilteredResponse, GetDictionaryWordsResponse, GetToolTitlesResponse, PostDictionaryProductsAttrsResponse, PostDictionaryProductsAttrsSubAttrsResponse, PostDictionaryProductsAttrsSubAttrsWordsResponse, PostDictionaryWordsResponse) {
  'use strict';

  /**
   * Tool service.
   * @module api/ToolApi
   * @version 0.0.5
   */

  /**
   * Constructs a new ToolApi. 
   * @alias module:api/ToolApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getDictionaryBrowseNodesAll operation.
     * @callback module:api/ToolApi~getDictionaryBrowseNodesAllCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetDictionaryBrowseNodesAllResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all dictionary hierarchy within a specified browse node
     * Return all dictionary hierarchy
     * @param {String} nodeId 
     * @param {module:api/ToolApi~getDictionaryBrowseNodesAllCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetDictionaryBrowseNodesAllResponse}
     */
    this.getDictionaryBrowseNodesAll = function(nodeId, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling getDictionaryBrowseNodesAll");
      }


      var pathParams = {
        'nodeId': nodeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetDictionaryBrowseNodesAllResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/browseNodes/{nodeId}/all', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDictionaryProductsAttrs operation.
     * @callback module:api/ToolApi~getDictionaryProductsAttrsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetDictionaryProductsAttrsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get an attribute within a specified browse node&#39;s
     * Return an attribute
     * @param {String} nodeId 
     * @param {String} attrId 
     * @param {module:api/ToolApi~getDictionaryProductsAttrsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetDictionaryProductsAttrsResponse}
     */
    this.getDictionaryProductsAttrs = function(nodeId, attrId, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling getDictionaryProductsAttrs");
      }

      // verify the required parameter 'attrId' is set
      if (attrId === undefined || attrId === null) {
        throw new Error("Missing the required parameter 'attrId' when calling getDictionaryProductsAttrs");
      }


      var pathParams = {
        'nodeId': nodeId,
        'attrId': attrId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetDictionaryProductsAttrsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/products/{nodeId}/attrs/{attrId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDictionaryProductsAttrsSubAttrs operation.
     * @callback module:api/ToolApi~getDictionaryProductsAttrsSubAttrsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetDictionaryProductsAttrsSubAttrsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a sub attribute within a specified browse node&#39;s attribute
     * Get a sub attribute
     * @param {String} nodeId 
     * @param {String} attrId 
     * @param {String} subAttrId 
     * @param {module:api/ToolApi~getDictionaryProductsAttrsSubAttrsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetDictionaryProductsAttrsSubAttrsResponse}
     */
    this.getDictionaryProductsAttrsSubAttrs = function(nodeId, attrId, subAttrId, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling getDictionaryProductsAttrsSubAttrs");
      }

      // verify the required parameter 'attrId' is set
      if (attrId === undefined || attrId === null) {
        throw new Error("Missing the required parameter 'attrId' when calling getDictionaryProductsAttrsSubAttrs");
      }

      // verify the required parameter 'subAttrId' is set
      if (subAttrId === undefined || subAttrId === null) {
        throw new Error("Missing the required parameter 'subAttrId' when calling getDictionaryProductsAttrsSubAttrs");
      }


      var pathParams = {
        'nodeId': nodeId,
        'attrId': attrId,
        'subAttrId': subAttrId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetDictionaryProductsAttrsSubAttrsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/products/{nodeId}/attrs/{attrId}/subAttrs/{subAttrId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDictionaryProductsAttrsSubAttrsWords operation.
     * @callback module:api/ToolApi~getDictionaryProductsAttrsSubAttrsWordsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetDictionaryProductsAttrsSubAttrsWordsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Check the dic_word contains within a specified browse node&#39;s attribute&#39;s sub attribute
     * Checket a dic_word contains
     * @param {String} nodeId 
     * @param {String} attrId 
     * @param {String} subAttrId 
     * @param {String} word 
     * @param {module:api/ToolApi~getDictionaryProductsAttrsSubAttrsWordsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetDictionaryProductsAttrsSubAttrsWordsResponse}
     */
    this.getDictionaryProductsAttrsSubAttrsWords = function(nodeId, attrId, subAttrId, word, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling getDictionaryProductsAttrsSubAttrsWords");
      }

      // verify the required parameter 'attrId' is set
      if (attrId === undefined || attrId === null) {
        throw new Error("Missing the required parameter 'attrId' when calling getDictionaryProductsAttrsSubAttrsWords");
      }

      // verify the required parameter 'subAttrId' is set
      if (subAttrId === undefined || subAttrId === null) {
        throw new Error("Missing the required parameter 'subAttrId' when calling getDictionaryProductsAttrsSubAttrsWords");
      }

      // verify the required parameter 'word' is set
      if (word === undefined || word === null) {
        throw new Error("Missing the required parameter 'word' when calling getDictionaryProductsAttrsSubAttrsWords");
      }


      var pathParams = {
        'nodeId': nodeId,
        'attrId': attrId,
        'subAttrId': subAttrId
      };
      var queryParams = {
        'word': word,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetDictionaryProductsAttrsSubAttrsWordsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/products/{nodeId}/attrs/{attrId}/subAttrs/{subAttrId}/words', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDictionarySubAttrsWords operation.
     * @callback module:api/ToolApi~getDictionarySubAttrsWordsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetDictionarySubAttrsWordsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get dictionary words with subAttrId list
     * Return Dictionary Words
     * @param {Array.<String>} subAttrIds 
     * @param {module:api/ToolApi~getDictionarySubAttrsWordsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetDictionarySubAttrsWordsResponse}
     */
    this.getDictionarySubAttrsWords = function(subAttrIds, callback) {
      var postBody = null;

      // verify the required parameter 'subAttrIds' is set
      if (subAttrIds === undefined || subAttrIds === null) {
        throw new Error("Missing the required parameter 'subAttrIds' when calling getDictionarySubAttrsWords");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
        'subAttrIds': {
          value: subAttrIds,
          collectionFormat: 'multi'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetDictionarySubAttrsWordsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/subAttrs/words', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDictionaryWords operation.
     * @callback module:api/ToolApi~getDictionaryWordsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetDictionaryWordsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * [DEPRECATED] Get dictionary words for filtering within specified browse nodes
     * [DEPRECATED] Return Dictionary Words for filtering ingredients
     * @param {Array.<String>} nodeIds 
     * @param {module:api/ToolApi~getDictionaryWordsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetDictionaryWordsResponse}
     */
    this.getDictionaryWords = function(nodeIds, callback) {
      var postBody = null;

      // verify the required parameter 'nodeIds' is set
      if (nodeIds === undefined || nodeIds === null) {
        throw new Error("Missing the required parameter 'nodeIds' when calling getDictionaryWords");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
        'nodeIds': {
          value: nodeIds,
          collectionFormat: 'multi'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetDictionaryWordsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/words', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDictionaryWordsFiltered operation.
     * @callback module:api/ToolApi~getDictionaryWordsFilteredCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetDictionaryWordsFilteredResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get filtered words within a specified browse node with filtering words
     * Return filtered words cloud
     * @param {String} nodeId 
     * @param {Array.<String>} filters 
     * @param {module:api/ToolApi~getDictionaryWordsFilteredCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetDictionaryWordsFilteredResponse}
     */
    this.getDictionaryWordsFiltered = function(nodeId, filters, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling getDictionaryWordsFiltered");
      }

      // verify the required parameter 'filters' is set
      if (filters === undefined || filters === null) {
        throw new Error("Missing the required parameter 'filters' when calling getDictionaryWordsFiltered");
      }


      var pathParams = {
        'nodeId': nodeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
        'filters': {
          value: filters,
          collectionFormat: 'multi'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetDictionaryWordsFilteredResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/words/{nodeId}/filtered', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getToolTitles operation.
     * @callback module:api/ToolApi~getToolTitlesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GetToolTitlesResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get 100 amazon best selling item titles within a specified browse node
     * Return Titles
     * @param {String} nodeId 
     * @param {module:api/ToolApi~getToolTitlesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GetToolTitlesResponse}
     */
    this.getToolTitles = function(nodeId, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling getToolTitles");
      }


      var pathParams = {
        'nodeId': nodeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GetToolTitlesResponse;

      return this.apiClient.callApi(
        '/tool/titles/{nodeId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the postDictionaryProductsAttrs operation.
     * @callback module:api/ToolApi~postDictionaryProductsAttrsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PostDictionaryProductsAttrsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add attribute within a specified browse node&#39;s
     * Add attribute
     * @param {String} nodeId 
     * @param {String} attrId 
     * @param {String} attrUsName Upserting if exists
     * @param {String} attrKrName Upserting if exists
     * @param {module:api/ToolApi~postDictionaryProductsAttrsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PostDictionaryProductsAttrsResponse}
     */
    this.postDictionaryProductsAttrs = function(nodeId, attrId, attrUsName, attrKrName, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling postDictionaryProductsAttrs");
      }

      // verify the required parameter 'attrId' is set
      if (attrId === undefined || attrId === null) {
        throw new Error("Missing the required parameter 'attrId' when calling postDictionaryProductsAttrs");
      }

      // verify the required parameter 'attrUsName' is set
      if (attrUsName === undefined || attrUsName === null) {
        throw new Error("Missing the required parameter 'attrUsName' when calling postDictionaryProductsAttrs");
      }

      // verify the required parameter 'attrKrName' is set
      if (attrKrName === undefined || attrKrName === null) {
        throw new Error("Missing the required parameter 'attrKrName' when calling postDictionaryProductsAttrs");
      }


      var pathParams = {
        'nodeId': nodeId,
        'attrId': attrId
      };
      var queryParams = {
        'attrUsName': attrUsName,
        'attrKrName': attrKrName,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PostDictionaryProductsAttrsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/products/{nodeId}/attrs/{attrId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the postDictionaryProductsAttrsSubAttrs operation.
     * @callback module:api/ToolApi~postDictionaryProductsAttrsSubAttrsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PostDictionaryProductsAttrsSubAttrsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add sub attribute within a specified browse node&#39;s attribute
     * Add sub attribute
     * @param {String} nodeId 
     * @param {String} attrId 
     * @param {String} subAttrId 
     * @param {String} subAttrUsName Upserting if exists
     * @param {String} subAttrKrName Upserting if exists
     * @param {module:api/ToolApi~postDictionaryProductsAttrsSubAttrsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PostDictionaryProductsAttrsSubAttrsResponse}
     */
    this.postDictionaryProductsAttrsSubAttrs = function(nodeId, attrId, subAttrId, subAttrUsName, subAttrKrName, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling postDictionaryProductsAttrsSubAttrs");
      }

      // verify the required parameter 'attrId' is set
      if (attrId === undefined || attrId === null) {
        throw new Error("Missing the required parameter 'attrId' when calling postDictionaryProductsAttrsSubAttrs");
      }

      // verify the required parameter 'subAttrId' is set
      if (subAttrId === undefined || subAttrId === null) {
        throw new Error("Missing the required parameter 'subAttrId' when calling postDictionaryProductsAttrsSubAttrs");
      }

      // verify the required parameter 'subAttrUsName' is set
      if (subAttrUsName === undefined || subAttrUsName === null) {
        throw new Error("Missing the required parameter 'subAttrUsName' when calling postDictionaryProductsAttrsSubAttrs");
      }

      // verify the required parameter 'subAttrKrName' is set
      if (subAttrKrName === undefined || subAttrKrName === null) {
        throw new Error("Missing the required parameter 'subAttrKrName' when calling postDictionaryProductsAttrsSubAttrs");
      }


      var pathParams = {
        'nodeId': nodeId,
        'attrId': attrId,
        'subAttrId': subAttrId
      };
      var queryParams = {
        'subAttrUsName': subAttrUsName,
        'subAttrKrName': subAttrKrName,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PostDictionaryProductsAttrsSubAttrsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/products/{nodeId}/attrs/{attrId}/subAttrs/{subAttrId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the postDictionaryProductsAttrsSubAttrsWords operation.
     * @callback module:api/ToolApi~postDictionaryProductsAttrsSubAttrsWordsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PostDictionaryProductsAttrsSubAttrsWordsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a dic_word within a specified browse node&#39;s attribute&#39;s sub attribute
     * Add a dic_word
     * @param {String} nodeId 
     * @param {String} attrId 
     * @param {String} subAttrId 
     * @param {String} word 
     * @param {module:api/ToolApi~postDictionaryProductsAttrsSubAttrsWordsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PostDictionaryProductsAttrsSubAttrsWordsResponse}
     */
    this.postDictionaryProductsAttrsSubAttrsWords = function(nodeId, attrId, subAttrId, word, callback) {
      var postBody = null;

      // verify the required parameter 'nodeId' is set
      if (nodeId === undefined || nodeId === null) {
        throw new Error("Missing the required parameter 'nodeId' when calling postDictionaryProductsAttrsSubAttrsWords");
      }

      // verify the required parameter 'attrId' is set
      if (attrId === undefined || attrId === null) {
        throw new Error("Missing the required parameter 'attrId' when calling postDictionaryProductsAttrsSubAttrsWords");
      }

      // verify the required parameter 'subAttrId' is set
      if (subAttrId === undefined || subAttrId === null) {
        throw new Error("Missing the required parameter 'subAttrId' when calling postDictionaryProductsAttrsSubAttrsWords");
      }

      // verify the required parameter 'word' is set
      if (word === undefined || word === null) {
        throw new Error("Missing the required parameter 'word' when calling postDictionaryProductsAttrsSubAttrsWords");
      }


      var pathParams = {
        'nodeId': nodeId,
        'attrId': attrId,
        'subAttrId': subAttrId
      };
      var queryParams = {
        'word': word,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PostDictionaryProductsAttrsSubAttrsWordsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/products/{nodeId}/attrs/{attrId}/subAttrs/{subAttrId}/words', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the postDictionaryWords operation.
     * @callback module:api/ToolApi~postDictionaryWordsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PostDictionaryWordsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * [DEPRECATED] Add filtering word to dictionary
     * [DEPRECATED] Add to dictionary
     * @param {String} subAttrId 
     * @param {String} word 
     * @param {module:api/ToolApi~postDictionaryWordsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PostDictionaryWordsResponse}
     */
    this.postDictionaryWords = function(subAttrId, word, callback) {
      var postBody = null;

      // verify the required parameter 'subAttrId' is set
      if (subAttrId === undefined || subAttrId === null) {
        throw new Error("Missing the required parameter 'subAttrId' when calling postDictionaryWords");
      }

      // verify the required parameter 'word' is set
      if (word === undefined || word === null) {
        throw new Error("Missing the required parameter 'word' when calling postDictionaryWords");
      }


      var pathParams = {
      };
      var queryParams = {
        'subAttrId': subAttrId,
        'word': word,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PostDictionaryWordsResponse;

      return this.apiClient.callApi(
        '/tool/dictionary/words', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
